SortGroupInformation = {};

local frame;
local GroupDown = false;
local GroupUp = false;
local cBDown;
local cBUp;
local btnReload;
local ddmProfiles;
local info;
local raidProfile;
local count = 1;

local function createFrame()
	frame = CreateFrame("Frame");
	frame.name = "SortGroup";
	font = frame:CreateFontString("SortGroup_Title", "OVERLAY", "GameFontHighlight");
	font:SetFont("Fonts\\FRIZQT__.TTF", 18);
	font:SetTextColor(1, 0.8, 0);
    font:SetPoint("TOPLEFT", 12, -18);
    font:SetText("Sort Group");
	InterfaceOptions_AddCategory(frame);
end

local function frameEvent()
	frame:RegisterEvent("COMPACT_UNIT_FRAME_PROFILES_LOADED");
	frame:RegisterEvent("PLAYER_ENTERING_WORLD");
	frame:RegisterEvent("PLAYER_LOGOUT");
	frame:SetScript("OnEvent", 
		function(self, event, ...)	
			if event == ( "PLAYER_LOGOUT" ) then 
				SortGroupInformation.Down = GroupDown;
				SortGroupInformation.Up = GroupUp;
				SortGroupInformation.Profile = raidProfile;
			elseif ( event == "COMPACT_UNIT_FRAME_PROFILES_LOADED" or event == "PLAYER_ENTERING_WORLD") then
				if ( SortGroupInformation.Down == nil or SortGroupInformation.Up == nil ) then
					SortGroupInformation.Down = true;
					SortGroupInformation.Up = false;
				end
				
				if ( SortGroupInformation.Profile == nil ) then
					SortGroupInformation.Profile = GetRaidProfileName(1);
				end
				
				GroupDown = SortGroupInformation.Down;
				GroupUp = SortGroupInformation.Up;
				raidProfile = SortGroupInformation.Profile;
				UIDropDownMenu_SetText(ddmProfiles, raidProfile);

				if ( GroupDown == true ) then
					cBDown:SetChecked(true);
					cBUp:SetChecked(false);
					GroupUp = false;
					SortBy('Down', raidProfile);
				end
				
				if ( GroupUp == true ) then
					cBDown:SetChecked(false);
					cBUp:SetChecked(true);
					GroupDown = false;
					SortBy('Up', raidProfile);
				end
				
				frame:UnregisterEvent(event);
				if ( HasLoadedCUFProfiles() == true ) then
					frame:RegisterEvent("PLAYER_ENTERING_WORLD");
				end
			end
		end);
end

local function createCheckbox()	
	cBDown = CreateFrame("CheckButton", "CheckButtonDown_Text", frame, "UICheckButtonTemplate");
	cBUp = CreateFrame("CheckButton", "CheckButtonUp_Text", frame, "UICheckButtonTemplate");
	
	cBDown:SetPoint("TOPLEFT", 10, -65);
	cBUp:SetPoint("TOPLEFT",10, -100);
	
	getglobal(cBDown:GetName() .. 'Text'):SetText("Sort Group down");
	getglobal(cBUp:GetName() .. 'Text'):SetText("Sort Group up");
end

local function checkBoxEvent()
	cBDown:SetScript("OnClick",
		function()
			if ( cBDown:GetChecked() == true ) then
				GroupDown = true;
				GroupUp = false;
				cBUp:SetChecked(false);
				count = 1;
				SortBy('Down', raidProfile);
			elseif ( cBDown:GetChecked() == false ) then	
				GroupDown = false;
				SortBy(nil,raidProfile);
			end
			InGroup();
		end);
		
	cBUp:SetScript("OnClick",
		function()
			if ( cBUp:GetChecked() == true ) then
				GroupDown = false;
				GroupUp = true;
				cBDown:SetChecked(false);
				count = 1;
				SortBy('Up', raidProfile);
			elseif ( cBUp:GetChecked() == false ) then	
				GroupUp = false;
				SortBy(nil,raidProfile);
			end
			InGroup();
		end);
end

local function createButton()
	btnReload = CreateFrame("Button", "Button_Text", frame, "UIPanelButtonTemplate");
	btnReload:SetSize(84, 24);
	btnReload:SetText("Reload UI");
	btnReload:SetPoint("TOPLEFT", 10, -150);
end

local function buttonEvent()
	btnReload:SetScript("OnClick", 
		function()
			ReloadUI();
		end);
end

local function dropDownMenuEvent(self, arg1, arg2, checked)
	raidProfile = GetRaidProfileName(arg1);
	count = 1;
	if( cBDown:GetChecked() == true ) then
		SortBy('Down',raidProfile);
	elseif (cBUp:GetChecked() == true ) then
		SortBy('Up',raidProfile);
	end
	UIDropDownMenu_SetText(ddmProfiles, raidProfile);
	InGroup();
end

local function createDropDownMenu()
	ddmProfiles = CreateFrame("Frame", "DropDownMenuProfiles", frame, "UIDropDownMenuTemplate");
	ddmProfiles:SetPoint("TOPLEFT", 220, -84);	
end

local function createDropDownMenuText()
	UIDropDownMenu_Initialize(ddmProfiles, 
		function(self, level, menuList)
			info = UIDropDownMenu_CreateInfo()
			info.func = dropDownMenuEvent;
			for i=1, GetNumRaidProfiles(), 1 do
				info.text, info.arg1 = GetRaidProfileName(i), i;
				UIDropDownMenu_AddButton(info)
			end
		end);	
end

function SortDown()
	CRFSort_Group = function(t1, t2)
		if UnitIsUnit(t1, "player") then 
			return true;
		elseif UnitIsUnit(t2, "player") then 
			return false;
		else 
			return t1 < t2;
		end 
	end
	CompactRaidFrameContainer.flowSortFunc=CRFSort_Group;
end
	
function SortUp()
	CRFSort_Group = function(t1, t2)
		if UnitIsUnit(t1, "player") then 
			return false;
		elseif UnitIsUnit(t2, "player") then 
			return true; 
		else 
			return t1 > t2;
		end 
	end
	CompactRaidFrameContainer.flowSortFunc=CRFSort_Group;
end

function SortBy(SortOption, RaidProfileName)	
	if ( GetNumGroupMembers() > 5 or RaidProfileName == nil) then
		--CompactUnitFrameProfilesGeneralOptionsFrameKeepGroupsTogether:Click(true);	
		--CompactUnitFrameProfilesGeneralOptionsFrameKeepGroupsTogether:Click(true);	
		--Do something to prevent blizzard frames get bugged. 
	elseif ( RaidProfileName ~= nil and HasLoadedCUFProfiles() == true) then
		if ( GetActiveRaidProfile() ~= RaidProfileName ) then
			CompactUnitFrameProfiles_ActivateRaidProfile(RaidProfileName);
		end		
		if ( CompactUnitFrameProfilesGeneralOptionsFrameKeepGroupsTogether:GetChecked() == true ) then
			CompactUnitFrameProfilesGeneralOptionsFrameKeepGroupsTogether:Click(true);				
		end	
		SetCVar("useCompactPartyFrames", 1);
		if ( SortOption == 'Down' ) then
			SortDown();
		elseif ( SortOption == 'Up' ) then
			SortUp();
		end
		if ( count == 1 ) then
			print("SortGroup Options:",RaidProfileName, "sorted", SortOption);
			count = 0;
		end
	end
end

function GetActiveRaidProfile()
	return GetCVar("activeCUFProfile");
end

function InGroup()
	if ( GetNumGroupMembers() > 1 ) then
		print("You are currently in a Group. Please Reload the UI, otherwise the changes will not work. You also have to be out of combat");
	end
end

createFrame();
frameEvent();
createCheckbox();
checkBoxEvent();
createButton();
buttonEvent();
createDropDownMenu();
createDropDownMenuText();